<?php
/*
please visit: http://www.libe.net/index.php/universelle-maehroboter-steuerung
and http://www.script-example.com for more details

Prerequisite:
# PHP CURL library
# PHP allow_url_fopen=on
# Crontab or Task Scheduler to periodically call the Page outsite the Timespans
# Configured Smartplug and Router Access to it
# Configured Variables in this Script:$timespan1, $timespan2, $smartplug (User, Password and IP)
# Modify Weather API Location and API-Key in this Script
# Write Access to values.json File
*/

/*-----------------------------------------------------------------------------
Variabledefinitions and Variablehandling
-----------------------------------------------------------------------------*/
$filevaluesjson="values.json";
//initial Settings:
$smartplug="http://admin:Password@xx.xxx.xxx.xxx:10000/smartplug.cgi";//not saved in values.json for Security Reason change Username, Password and IP/Port
$strjson = '
{
    "too_much_rain": "2",
    "timespan1": 
		{"start":"06:30",
		 "end":"09:00"
		},
	"timespan2": 
		{"start":"19:30",
		 "end":"23:30"
		},
    "crontimes":"01:55,02:55,03:55,04:55,05:55,06:55,07:55,08:55,10:55,11:55,12:55,13:55,14:55,15:55,16:55,17:55,18:55,20:55,21:55,22:55,06:20,19:20",
    "too_much_rain": "2",
	"sendermail":"myemail@myemail.loc",
	"mailto":"myemail@myemail.loc",
	"mower_name":"Mower",
	"manual":"auto",
	"openweathermapurl":"http://api.openweathermap.org/data/2.5/forecast?id=xxx&appid=xxxxxxxxxxxx",
	"on":"<?xml version=\"1.0\" encoding=\"utf-8\"?><SMARTPLUG id=\"edimax\"><CMD id=\"setup\"><Device.System.Power.State>ON</Device.System.Power.State></CMD></SMARTPLUG>",
	"off":"<?xml version=\"1.0\" encoding=\"utf-8\"?><SMARTPLUG id=\"edimax\"><CMD id=\"setup\"><Device.System.Power.State>OFF</Device.System.Power.State></CMD></SMARTPLUG>"
}';

function smartplug($smartplug,$action)
{$ch = curl_init();curl_setopt($ch,CURLOPT_URL, $smartplug);//url
curl_setopt($ch,CURLOPT_POST, count($action));curl_setopt($ch,CURLOPT_POSTFIELDS, $action);
curl_setopt($ch,CURLOPT_RETURNTRANSFER, 1);//return result
$result = curl_exec($ch);curl_close($ch);return $result;}

$arrtimes=array('0','2','5','8','11','14','17','20','23');
function realhour($hour){if ($hour<0) return "00:00";if ($hour<10)$hour="0".$hour.":00";else $hour=$hour.":00";return $hour;}

//merge initial Settings and Saved Data to Settings Array $arr
$arr= json_decode($strjson,true);//build Array and write initial settings
if (!file_exists($filevaluesjson)){file_put_contents($filevaluesjson,json_encode($arr));$arr["last_update_runtime"]=$timenow;}
$strfilevaluesjson=file_get_contents($filevaluesjson); //get json variables from File and update initial Settings:
if (!empty($strfilevaluesjson)){$arrfilevaluesjson= json_decode($strfilevaluesjson,true);$arr=array_merge($arr, $arrfilevaluesjson);}

$timenow=date('H:i', time());//$timespan1e=explode("-",$arr['timespan1']);$timespan2e=explode("-",$arr['timespan2']);

//test if update.php is called twice 
if ($arr["last_update_runtime"]!=date('H:i d.m.Y', time()))
	{
		$arr["last_update_runtime"]=date('H:i d.m.Y', time());
	}else {echo "Script is running in this minute";exit;die();}


//load Weatherdata from Openweathermap:
$string=file_get_contents($arr['openweathermapurl']);
if (strlen($string)>1000) $downloadopenweather="ok";
$obj =(json_decode($string));
//echo $string;
foreach($obj->list as $mydata)
{
while (list($key, $value) = each($mydata->rain)) 
		{	
		 $arr['weatherdata_openweathermaps'][date('Ymd',$mydata->dt)][date('H:i',$mydata->dt)]=$value;
		 }
	}


//merge individual weather data arrays to one array:
//it is possible to merge more data: $arr["weatherdata"][date('Ymd')]=array_merge($arr['weatherdata_openweathermaps'][date('Ymd')], $arr["weatherdata_additionalweatherdata"][date('Ymd')]);
$arr["weatherdata"][date('Ymd')]=$arr['weatherdata_openweathermaps'][date('Ymd')];

//calc
$arr["rain"][date('Ymd')]="0";
while (list($key, $value) = each($arr["weatherdata"][date('Ymd')]))
{
	if ($timenow<=$arr[timespan1]["end"]){//timespan1 ignore Rain after timespan1:
		if (trim($key)<trim($arr[timespan1]["end"])){ $arr["rain"][date('Ymd')]=$arr["rain"][date('Ymd')]+$value;echo $key. " addvalue".$value."rain".$arr["rain"][date('Ymd')]."<br>";}
		
	}else
	{//timespan2
	if (trim($key)>=$arr[timespan2]["start"]) 
		{$arr["rain"][date('Ymd')]=$arr["rain"][date('Ymd')]+$value;
		 echo $key.":+".$value."<br>";
		}else
		{
		$arr["rain"][date('Ymd')]=$arr["rain"][date('Ymd')]+($value/2);
		echo $key.":+ 1/2: ".($value/2)."<br>";
		}
	}
}

//for morning: additional values from yesterday:
if ($timenow<=$arr["timespan1"]["end"]){
while (list($key, $value) = each($arr["weatherdata"][date('Ymd', strtotime('-1 days'))]))
{$arr["rain"][date('Ymd')]=$arr["rain"][date('Ymd')]+$value;}
$arr["calctimespan"]="timespan1";
}else $arr["calctimespan"]="timespan2";
$raingr0=0;

//when rain>$too_much_rain on last 2 days: too_much_rain=0 
if ($timenow<=$arr["timespan1"]["end"]) $numdays=3; else $numdays=2;
			for ($x = 1; $x <= $numdays; $x++) 	{$vallastday=$arr["rain"][date('Ymd', strtotime('-'.$x.' days'))];if ($vallastday>$arr["too_much_rain"]) $raingr0++;}
if ($raingr0>=2){echo "on the last 2 days: $raingr0 raindays change threshold to 0";$arr["actual_too_much_rain"]=0;}else $arr["actual_too_much_rain"]=$arr["too_much_rain"];
//end change too_much_rain

//cleanup old data:
$historydays=7;
while (list($key, $value) = each($arr["weatherdata"])) 
{	if ($key<date('Ymd', strtotime('-'.$historydays.' days'))) 
	{echo "cleanup:".date('Ymd', strtotime('-'.$historydays.' days'));
	 unset($arr["rain"][$key]);
	 unset($arr["weatherdata"][$key]);
	 unset($arr["weatherdata_openweathermaps"][$key]);
	 unset($arr['weatherdata_forecastio_Probability'][$key]);
	 unset($arr['weatherdata_forecastio_Intensity'][$key]);
	}
}

//reset manual to auto
$arr["manual"]=trim($arr["manual"]);

if ((($timenow<$arr["timespan1"]["start"] or $timenow > $arr["timespan1"]["end"]) and ($timenow<$arr["timespan2"]["start"] or $timenow > $arr["timespan2"]["end"])) or $arr["manual"]=="on" or $arr["manual"]=="on".date('Ymd')) 
	
{//not in timespan1 or 2
/*-------------------------------------------------------------------------------------
Turn the Smartplug on or off:
-------------------------------------------------------------------------------------*/
//Ein und Aus-Schalten ...
if (!empty($_GET["test"]))$arr["rain"][date('Ymd')]=$_GET["test"];
if (($arr["rain"][date('Ymd')]>$arr["actual_too_much_rain"] and $arr["manual"]!="on" and $arr["manual"]!="on".date('Ymd')) or $arr["manual"]=="off" or $arr["manual"]=="off".date('Ymd') or ($arr["manual"]=="off".date('Ymd', strtotime('-1 days')) and $timenow < $arr["timespan1"]["end"])) 
{//power off ...			   
	$arr["smartplug_answer"]=smartplug($smartplug,$arr["off"]); 
	//2nd try:
	if (strlen($arr["smartplug_answer"])<2) $arr["smartplug_answer"]=smartplug($smartplug,$arr["off"]);
	if (strlen($arr["smartplug_answer"])>2){if ($arr["power"]!="off") $arr["powerchanged"]=date('Ymd H:i'); $arr["power"]="off";$arr["errorcounter"]="0";}
} else 
{//power on ...
	$arr["smartplug_answer"]=smartplug($smartplug,$arr["on"]);
	if (strlen($arr["smartplug_answer"])<2) $arr["smartplug_answer"]=smartplug($smartplug,$arr["on"]);//..2nd try
	if (strlen($arr["smartplug_answer"])>2){if ($arr["power"]!="on") $arr["powerchanged"]=date('Ymd H:i');$arr["power"]="on";$arr["errorcounter"]="0";} 
}
if (strlen($arr["smartplug_answer"])<2){$arr["power"]="no";}
echo "Antwort:".$arr["smartplug_answer"];
}//end. not in timespan1 or 2

/*-------------------------------------------------------------------------------------
Mail on errors:
-------------------------------------------------------------------------------------*/
if (strlen($arr["smartplug_answer"])<=2) {$arr["errorcounter"]++;$arr["smartplug_answer"]=$arr["errorcounter"];}
if ($arr["errorcounter"]==3 or $arr["errorcounter"]==6) {
$headers = "From:" . $arr[sendermail];
mail($mailto, 'Warnung Smartplug not accessible', "The Smartplug was not accessible",$headers, "-f ".$arr[sendermail]);
}

echo "<h1>Array:</h1>";
print_r($arr);

//save all Values to json-File:
file_put_contents($filevaluesjson,json_encode($arr));

?>
